diff -crBPN --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=advanced-cache.php --exclude=wp-cache-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.5.pl /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-admin/includes/class-wp-media-list-table.php /home/packages/code/qi/SOURCES/wordpress-3.5/wp-admin/includes/class-wp-media-list-table.php
*** /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-admin/includes/class-wp-media-list-table.php	2012-10-29 12:35:30.000000000 -0500
--- /home/packages/code/qi/SOURCES/wordpress-3.5/wp-admin/includes/class-wp-media-list-table.php	2012-12-17 16:18:41.000000000 -0600
***************
*** 9,19 ****
   */
  class WP_Media_List_Table extends WP_List_Table {
  
! 	function __construct() {
  		$this->detached = isset( $_REQUEST['detached'] ) || isset( $_REQUEST['find_detached'] );
  
  		parent::__construct( array(
! 			'plural' => 'media'
  		) );
  	}
  
--- 9,20 ----
   */
  class WP_Media_List_Table extends WP_List_Table {
  
! 	function __construct( $args = array() ) {
  		$this->detached = isset( $_REQUEST['detached'] ) || isset( $_REQUEST['find_detached'] );
  
  		parent::__construct( array(
! 			'plural' => 'media',
! 			'screen' => isset( $args['screen'] ) ? $args['screen'] : null,
  		) );
  	}
  
***************
*** 91,103 ****
  			$this->months_dropdown( 'attachment' );
  
  			do_action( 'restrict_manage_posts' );
! 			submit_button( __( 'Filter' ), 'secondary', false, false, array( 'id' => 'post-query-submit' ) );
  		}
  
  		if ( $this->detached ) {
  			submit_button( __( 'Scan for lost attachments' ), 'secondary', 'find_detached', false );
  		} elseif ( $this->is_trash && current_user_can( 'edit_others_posts' ) ) {
! 			submit_button( __( 'Empty Trash' ), 'button-secondary apply', 'delete_all', false );
  		} ?>
  		</div>
  <?php
--- 92,104 ----
  			$this->months_dropdown( 'attachment' );
  
  			do_action( 'restrict_manage_posts' );
! 			submit_button( __( 'Filter' ), 'button', false, false, array( 'id' => 'post-query-submit' ) );
  		}
  
  		if ( $this->detached ) {
  			submit_button( __( 'Scan for lost attachments' ), 'secondary', 'find_detached', false );
  		} elseif ( $this->is_trash && current_user_can( 'edit_others_posts' ) ) {
! 			submit_button( __( 'Empty Trash' ), 'apply', 'delete_all', false );
  		} ?>
  		</div>
  <?php
***************
*** 131,142 ****
  		/* translators: column name */
  		$posts_columns['title'] = _x( 'File', 'column name' );
  		$posts_columns['author'] = __( 'Author' );
! 		//$posts_columns['tags'] = _x( 'Tags', 'column name' );
  		/* translators: column name */
  		if ( !$this->detached ) {
! 			$posts_columns['parent'] = _x( 'Attached to', 'column name' );
  			if ( post_type_supports( 'attachment', 'comments' ) )
! 				$posts_columns['comments'] = '<span class="vers"><img alt="' . esc_attr__( 'Comments' ) . '" src="' . esc_url( admin_url( 'images/comment-grey-bubble.png' ) ) . '" /></span>';
  		}
  		/* translators: column name */
  		$posts_columns['date'] = _x( 'Date', 'column name' );
--- 132,162 ----
  		/* translators: column name */
  		$posts_columns['title'] = _x( 'File', 'column name' );
  		$posts_columns['author'] = __( 'Author' );
! 
! 		$taxonomies = array();
! 
! 		$taxonomies = get_taxonomies_for_attachments( 'objects' );
! 		$taxonomies = wp_filter_object_list( $taxonomies, array( 'show_admin_column' => true ), 'and', 'name' );
! 
! 		$taxonomies = apply_filters( 'manage_taxonomies_for_attachment_columns', $taxonomies, 'attachment' );
! 		$taxonomies = array_filter( $taxonomies, 'taxonomy_exists' );
! 
! 		foreach ( $taxonomies as $taxonomy ) {
! 			if ( 'category' == $taxonomy )
! 				$column_key = 'categories';
! 			elseif ( 'post_tag' == $taxonomy )
! 				$column_key = 'tags';
! 			else
! 				$column_key = 'taxonomy-' . $taxonomy;
! 
! 			$posts_columns[ $column_key ] = get_taxonomy( $taxonomy )->labels->name;
! 		}
! 
  		/* translators: column name */
  		if ( !$this->detached ) {
! 			$posts_columns['parent'] = _x( 'Uploaded to', 'column name' );
  			if ( post_type_supports( 'attachment', 'comments' ) )
! 				$posts_columns['comments'] = '<span class="vers"><div title="' . esc_attr__( 'Comments' ) . '" class="comment-grey-bubble"></div></span>';
  		}
  		/* translators: column name */
  		$posts_columns['date'] = _x( 'Date', 'column name' );
***************
*** 191,197 ****
  ?>
  		<th scope="row" class="check-column">
  			<?php if ( $user_can_edit ) { ?>
! 				<input type="checkbox" name="media[]" value="<?php the_ID(); ?>" />
  			<?php } ?>
  		</th>
  <?php
--- 211,218 ----
  ?>
  		<th scope="row" class="check-column">
  			<?php if ( $user_can_edit ) { ?>
! 				<label class="screen-reader-text" for="cb-select-<?php the_ID(); ?>"><?php echo sprintf( __( 'Select %s' ), $att_title );?></label>
! 				<input type="checkbox" name="media[]" id="cb-select-<?php the_ID(); ?>" value="<?php the_ID(); ?>" />
  			<?php } ?>
  		</th>
  <?php
***************
*** 249,271 ****
  <?php
  		break;
  
- 	case 'tags':
- ?>
- 		<td <?php echo $attributes ?>><?php
- 		$tags = get_the_tags();
- 		if ( !empty( $tags ) ) {
- 			$out = array();
- 			foreach ( $tags as $c )
- 				$out[] = "<a href='edit.php?tag=$c->slug'> " . esc_html( sanitize_term_field( 'name', $c->name, $c->term_id, 'post_tag', 'display' ) ) . "</a>";
- 			echo join( ', ', $out );
- 		} else {
- 			_e( 'No Tags' );
- 		}
- ?>
- 		</td>
- <?php
- 		break;
- 
  	case 'desc':
  ?>
  		<td <?php echo $attributes ?>><?php echo has_excerpt() ? $post->post_excerpt : ''; ?></td>
--- 270,275 ----
***************
*** 273,285 ****
  		break;
  
  	case 'date':
! 		if ( '0000-00-00 00:00:00' == $post->post_date && 'date' == $column_name ) {
! 			$t_time = $h_time = __( 'Unpublished' );
  		} else {
- 			$t_time = get_the_time( __( 'Y/m/d g:i:s A' ) );
  			$m_time = $post->post_date;
  			$time = get_post_time( 'G', true, $post, false );
! 			if ( ( abs( $t_diff = time() - $time ) ) < 86400 ) {
  				if ( $t_diff < 0 )
  					$h_time = sprintf( __( '%s from now' ), human_time_diff( $time ) );
  				else
--- 277,288 ----
  		break;
  
  	case 'date':
! 		if ( '0000-00-00 00:00:00' == $post->post_date ) {
! 			$h_time = __( 'Unpublished' );
  		} else {
  			$m_time = $post->post_date;
  			$time = get_post_time( 'G', true, $post, false );
! 			if ( ( abs( $t_diff = time() - $time ) ) < DAY_IN_SECONDS ) {
  				if ( $t_diff < 0 )
  					$h_time = sprintf( __( '%s from now' ), human_time_diff( $time ) );
  				else
***************
*** 338,343 ****
--- 341,378 ----
  		break;
  
  	default:
+ 		if ( 'categories' == $column_name )
+ 			$taxonomy = 'category';
+ 		elseif ( 'tags' == $column_name )
+ 			$taxonomy = 'post_tag';
+ 		elseif ( 0 === strpos( $column_name, 'taxonomy-' ) )
+ 			$taxonomy = substr( $column_name, 9 );
+ 		else
+ 			$taxonomy = false;
+ 
+ 		if ( $taxonomy ) {
+ 			$taxonomy_object = get_taxonomy( $taxonomy );
+ 			echo '<td ' . $attributes . '>';
+ 			if ( $terms = get_the_terms( $post->ID, $taxonomy ) ) {
+ 				$out = array();
+ 				foreach ( $terms as $t ) {
+ 					$posts_in_term_qv = array();
+ 					$posts_in_term_qv['taxonomy'] = $taxonomy;
+ 					$posts_in_term_qv['term'] = $t->slug;
+ 
+ 					$out[] = sprintf( '<a href="%s">%s</a>',
+ 						esc_url( add_query_arg( $posts_in_term_qv, 'upload.php' ) ),
+ 						esc_html( sanitize_term_field( 'name', $t->name, $t->term_id, $taxonomy, 'display' ) )
+ 					);
+ 				}
+ 				/* translators: used between list items, there is a space after the comma */
+ 				echo join( __( ', ' ), $out );
+ 			} else {
+ 				echo '&#8212;';
+ 			}
+ 			echo '</td>';
+ 			break;
+ 		}
  ?>
  		<td <?php echo $attributes ?>>
  			<?php do_action( 'manage_media_custom_column', $column_name, $id ); ?>
***************
*** 359,368 ****
  				$actions['edit'] = '<a href="' . get_edit_post_link( $post->ID, true ) . '">' . __( 'Edit' ) . '</a>';
  			if ( current_user_can( 'delete_post', $post->ID ) )
  				if ( EMPTY_TRASH_DAYS && MEDIA_TRASH ) {
! 					$actions['trash'] = "<a class='submitdelete' href='" . wp_nonce_url( "post.php?action=trash&amp;post=$post->ID", 'trash-attachment_' . $post->ID ) . "'>" . __( 'Trash' ) . "</a>";
  				} else {
  					$delete_ays = !MEDIA_TRASH ? " onclick='return showNotice.warn();'" : '';
! 					$actions['delete'] = "<a class='submitdelete'$delete_ays href='" . wp_nonce_url( "post.php?action=delete&amp;post=$post->ID", 'delete-attachment_' . $post->ID ) . "'>" . __( 'Delete Permanently' ) . "</a>";
  				}
  			$actions['view'] = '<a href="' . get_permalink( $post->ID ) . '" title="' . esc_attr( sprintf( __( 'View &#8220;%s&#8221;' ), $att_title ) ) . '" rel="permalink">' . __( 'View' ) . '</a>';
  			if ( current_user_can( 'edit_post', $post->ID ) )
--- 394,403 ----
  				$actions['edit'] = '<a href="' . get_edit_post_link( $post->ID, true ) . '">' . __( 'Edit' ) . '</a>';
  			if ( current_user_can( 'delete_post', $post->ID ) )
  				if ( EMPTY_TRASH_DAYS && MEDIA_TRASH ) {
! 					$actions['trash'] = "<a class='submitdelete' href='" . wp_nonce_url( "post.php?action=trash&amp;post=$post->ID", 'trash-post_' . $post->ID ) . "'>" . __( 'Trash' ) . "</a>";
  				} else {
  					$delete_ays = !MEDIA_TRASH ? " onclick='return showNotice.warn();'" : '';
! 					$actions['delete'] = "<a class='submitdelete'$delete_ays href='" . wp_nonce_url( "post.php?action=delete&amp;post=$post->ID", 'delete-post_' . $post->ID ) . "'>" . __( 'Delete Permanently' ) . "</a>";
  				}
  			$actions['view'] = '<a href="' . get_permalink( $post->ID ) . '" title="' . esc_attr( sprintf( __( 'View &#8220;%s&#8221;' ), $att_title ) ) . '" rel="permalink">' . __( 'View' ) . '</a>';
  			if ( current_user_can( 'edit_post', $post->ID ) )
***************
*** 373,384 ****
  				$actions['edit'] = '<a href="' . get_edit_post_link( $post->ID, true ) . '">' . __( 'Edit' ) . '</a>';
  			if ( current_user_can( 'delete_post', $post->ID ) ) {
  				if ( $this->is_trash )
! 					$actions['untrash'] = "<a class='submitdelete' href='" . wp_nonce_url( "post.php?action=untrash&amp;post=$post->ID", 'untrash-attachment_' . $post->ID ) . "'>" . __( 'Restore' ) . "</a>";
  				elseif ( EMPTY_TRASH_DAYS && MEDIA_TRASH )
! 					$actions['trash'] = "<a class='submitdelete' href='" . wp_nonce_url( "post.php?action=trash&amp;post=$post->ID", 'trash-attachment_' . $post->ID ) . "'>" . __( 'Trash' ) . "</a>";
  				if ( $this->is_trash || !EMPTY_TRASH_DAYS || !MEDIA_TRASH ) {
  					$delete_ays = ( !$this->is_trash && !MEDIA_TRASH ) ? " onclick='return showNotice.warn();'" : '';
! 					$actions['delete'] = "<a class='submitdelete'$delete_ays href='" . wp_nonce_url( "post.php?action=delete&amp;post=$post->ID", 'delete-attachment_' . $post->ID ) . "'>" . __( 'Delete Permanently' ) . "</a>";
  				}
  			}
  			if ( !$this->is_trash ) {
--- 408,419 ----
  				$actions['edit'] = '<a href="' . get_edit_post_link( $post->ID, true ) . '">' . __( 'Edit' ) . '</a>';
  			if ( current_user_can( 'delete_post', $post->ID ) ) {
  				if ( $this->is_trash )
! 					$actions['untrash'] = "<a class='submitdelete' href='" . wp_nonce_url( "post.php?action=untrash&amp;post=$post->ID", 'untrash-post_' . $post->ID ) . "'>" . __( 'Restore' ) . "</a>";
  				elseif ( EMPTY_TRASH_DAYS && MEDIA_TRASH )
! 					$actions['trash'] = "<a class='submitdelete' href='" . wp_nonce_url( "post.php?action=trash&amp;post=$post->ID", 'trash-post_' . $post->ID ) . "'>" . __( 'Trash' ) . "</a>";
  				if ( $this->is_trash || !EMPTY_TRASH_DAYS || !MEDIA_TRASH ) {
  					$delete_ays = ( !$this->is_trash && !MEDIA_TRASH ) ? " onclick='return showNotice.warn();'" : '';
! 					$actions['delete'] = "<a class='submitdelete'$delete_ays href='" . wp_nonce_url( "post.php?action=delete&amp;post=$post->ID", 'delete-post_' . $post->ID ) . "'>" . __( 'Delete Permanently' ) . "</a>";
  				}
  			}
  			if ( !$this->is_trash ) {
diff -crBPN --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=advanced-cache.php --exclude=wp-cache-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.5.pl /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-admin/includes/class-wp-ms-sites-list-table.php /home/packages/code/qi/SOURCES/wordpress-3.5/wp-admin/includes/class-wp-ms-sites-list-table.php
*** /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-admin/includes/class-wp-ms-sites-list-table.php	2012-10-29 12:35:31.000000000 -0500
--- /home/packages/code/qi/SOURCES/wordpress-3.5/wp-admin/includes/class-wp-ms-sites-list-table.php	2012-12-17 16:18:41.000000000 -0600
***************
*** 9,17 ****
   */
  class WP_MS_Sites_List_Table extends WP_List_Table {
  
! 	function __construct() {
  		parent::__construct( array(
  			'plural' => 'sites',
  		) );
  	}
  
--- 9,18 ----
   */
  class WP_MS_Sites_List_Table extends WP_List_Table {
  
! 	function __construct( $args = array() ) {
  		parent::__construct( array(
  			'plural' => 'sites',
+ 			'screen' => isset( $args['screen'] ) ? $args['screen'] : null,
  		) );
  	}
  
***************
*** 213,218 ****
--- 214,220 ----
  				switch ( $column_name ) {
  					case 'cb': ?>
  						<th scope="row" class="check-column">
+ 							<label class="screen-reader-text" for="blog_<?php echo $blog['blog_id']; ?>"><?php printf( __( 'Select %s' ), $blogname ); ?></label>
  							<input type="checkbox" id="blog_<?php echo $blog['blog_id'] ?>" name="allblogs[]" value="<?php echo esc_attr( $blog['blog_id'] ) ?>" />
  						</th>
  					<?php
***************
*** 229,236 ****
  						echo "<td class='column-$column_name $column_name'$style>"; ?>
  							<a href="<?php echo esc_url( network_admin_url( 'site-info.php?id=' . $blog['blog_id'] ) ); ?>" class="edit"><?php echo $blogname . $blog_state; ?></a>
  							<?php
! 							if ( 'list' != $mode )
! 								echo '<p>' . sprintf( _x( '%1$s &#8211; <em>%2$s</em>', '%1$s: site name. %2$s: site tagline.' ), get_blog_option( $blog['blog_id'], 'blogname' ), get_blog_option( $blog['blog_id'], 'blogdescription ' ) ) . '</p>';
  
  							// Preordered.
  							$actions = array(
--- 231,241 ----
  						echo "<td class='column-$column_name $column_name'$style>"; ?>
  							<a href="<?php echo esc_url( network_admin_url( 'site-info.php?id=' . $blog['blog_id'] ) ); ?>" class="edit"><?php echo $blogname . $blog_state; ?></a>
  							<?php
! 							if ( 'list' != $mode ) {
! 								switch_to_blog( $blog['blog_id'] );
! 								echo '<p>' . sprintf( _x( '%1$s &#8211; <em>%2$s</em>', '%1$s: site name. %2$s: site tagline.' ), get_option( 'blogname' ), get_option( 'blogdescription ' ) ) . '</p>';
! 								restore_current_blog();
! 							}
  
  							// Preordered.
  							$actions = array(
***************
*** 264,270 ****
  									$actions['delete']	= '<span class="delete"><a href="' . esc_url( wp_nonce_url( network_admin_url( 'sites.php?action=confirm&amp;action2=deleteblog&amp;id=' . $blog['blog_id'] . '&amp;msg=' . urlencode( sprintf( __( 'You are about to delete the site %s.' ), $blogname ) ) ), 'confirm') ) . '">' . __( 'Delete' ) . '</a></span>';
  							}
  
! 							$actions['visit']	= "<span class='view'><a href='" . esc_url( get_home_url( $blog['blog_id'] ) ) . "' rel='permalink'>" . __( 'Visit' ) . '</a></span>';
  
  							$actions = apply_filters( 'manage_sites_action_links', array_filter( $actions ), $blog['blog_id'], $blogname );
  							echo $this->row_actions( $actions );
--- 269,275 ----
  									$actions['delete']	= '<span class="delete"><a href="' . esc_url( wp_nonce_url( network_admin_url( 'sites.php?action=confirm&amp;action2=deleteblog&amp;id=' . $blog['blog_id'] . '&amp;msg=' . urlencode( sprintf( __( 'You are about to delete the site %s.' ), $blogname ) ) ), 'confirm') ) . '">' . __( 'Delete' ) . '</a></span>';
  							}
  
! 							$actions['visit']	= "<span class='view'><a href='" . esc_url( get_home_url( $blog['blog_id'], '/' ) ) . "' rel='permalink'>" . __( 'Visit' ) . '</a></span>';
  
  							$actions = apply_filters( 'manage_sites_action_links', array_filter( $actions ), $blog['blog_id'], $blogname );
  							echo $this->row_actions( $actions );
diff -crBPN --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=advanced-cache.php --exclude=wp-cache-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.5.pl /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-admin/includes/class-wp-ms-themes-list-table.php /home/packages/code/qi/SOURCES/wordpress-3.5/wp-admin/includes/class-wp-ms-themes-list-table.php
*** /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-admin/includes/class-wp-ms-themes-list-table.php	2012-10-29 12:35:31.000000000 -0500
--- /home/packages/code/qi/SOURCES/wordpress-3.5/wp-admin/includes/class-wp-ms-themes-list-table.php	2012-12-17 16:18:41.000000000 -0600
***************
*** 12,35 ****
  	var $site_id;
  	var $is_site_themes;
  
! 	function __construct() {
  		global $status, $page;
  
  		$status = isset( $_REQUEST['theme_status'] ) ? $_REQUEST['theme_status'] : 'all';
  		if ( !in_array( $status, array( 'all', 'enabled', 'disabled', 'upgrade', 'search', 'broken' ) ) )
  			$status = 'all';
  
  		$page = $this->get_pagenum();
  
! 		$screen = get_current_screen();
! 		$this->is_site_themes = ( 'site-themes-network' == $screen->id ) ? true : false;
  
  		if ( $this->is_site_themes )
  			$this->site_id = isset( $_REQUEST['id'] ) ? intval( $_REQUEST['id'] ) : 0;
- 
- 		parent::__construct( array(
- 			'plural' => 'themes'
- 		) );
  	}
  
  	function get_table_classes() {
--- 12,35 ----
  	var $site_id;
  	var $is_site_themes;
  
! 	function __construct( $args = array() ) {
  		global $status, $page;
  
+ 		parent::__construct( array(
+ 			'plural' => 'themes',
+ 			'screen' => isset( $args['screen'] ) ? $args['screen'] : null,
+ 		) );
+ 
  		$status = isset( $_REQUEST['theme_status'] ) ? $_REQUEST['theme_status'] : 'all';
  		if ( !in_array( $status, array( 'all', 'enabled', 'disabled', 'upgrade', 'search', 'broken' ) ) )
  			$status = 'all';
  
  		$page = $this->get_pagenum();
  
! 		$this->is_site_themes = ( 'site-themes-network' == $this->screen->id ) ? true : false;
  
  		if ( $this->is_site_themes )
  			$this->site_id = isset( $_REQUEST['id'] ) ? intval( $_REQUEST['id'] ) : 0;
  	}
  
  	function get_table_classes() {
***************
*** 37,52 ****
  	}
  
  	function ajax_user_can() {
! 		$menu_perms = get_site_option( 'menu_items', array() );
! 
! 		if ( empty( $menu_perms['themes'] ) && ! is_super_admin() )
! 			return false;
! 
! 		if ( $this->is_site_themes && !current_user_can('manage_sites') )
! 			return false;
! 		elseif ( !$this->is_site_themes && !current_user_can('manage_network_themes') )
! 			return false;
! 		return true;
  	}
  
  	function prepare_items() {
--- 37,46 ----
  	}
  
  	function ajax_user_can() {
! 		if ( $this->is_site_themes )
! 			return current_user_can( 'manage_sites' );
! 		else
! 			return current_user_can( 'manage_network_themes' );
  	}
  
  	function prepare_items() {
***************
*** 240,262 ****
  		if ( 'disabled' != $status )
  			$actions['disable-selected'] = $this->is_site_themes ? __( 'Disable' ) : __( 'Network Disable' );
  		if ( ! $this->is_site_themes ) {
- 			if ( current_user_can( 'delete_themes' ) )
- 				$actions['delete-selected'] = __( 'Delete' );
  			if ( current_user_can( 'update_themes' ) )
  				$actions['update-selected'] = __( 'Update' );
  		}
  		return $actions;
  	}
  
- 	function bulk_actions( $which ) {
- 		global $status;
- 		parent::bulk_actions( $which );
- 	}
- 
- 	function current_action() {
- 		return parent::current_action();
- 	}
- 
  	function display_rows() {
  		foreach ( $this->items as $key => $theme )
  			$this->single_row( $key, $theme );
--- 234,247 ----
  		if ( 'disabled' != $status )
  			$actions['disable-selected'] = $this->is_site_themes ? __( 'Disable' ) : __( 'Network Disable' );
  		if ( ! $this->is_site_themes ) {
  			if ( current_user_can( 'update_themes' ) )
  				$actions['update-selected'] = __( 'Update' );
+ 			if ( current_user_can( 'delete_themes' ) )
+ 				$actions['delete-selected'] = __( 'Delete' );
  		}
  		return $actions;
  	}
  
  	function display_rows() {
  		foreach ( $this->items as $key => $theme )
  			$this->single_row( $key, $theme );
***************
*** 283,309 ****
  			'delete' => ''
  		);
  
! 		$theme_key = $theme->get_stylesheet();
  
  		if ( ! $allowed ) {
  			if ( ! $theme->errors() )
! 				$actions['enable'] = '<a href="' . esc_url( wp_nonce_url($url . 'action=enable&amp;theme=' . $theme_key . '&amp;paged=' . $page . '&amp;s=' . $s, 'enable-theme_' . $theme_key) ) . '" title="' . esc_attr__('Enable this theme') . '" class="edit">' . ( $this->is_site_themes ? __( 'Enable' ) : __( 'Network Enable' ) ) . '</a>';
  		} else {
! 			$actions['disable'] = '<a href="' . esc_url( wp_nonce_url($url . 'action=disable&amp;theme=' . $theme_key . '&amp;paged=' . $page . '&amp;s=' . $s, 'disable-theme_' . $theme_key) ) . '" title="' . esc_attr__('Disable this theme') . '">' . ( $this->is_site_themes ? __( 'Disable' ) : __( 'Network Disable' ) ) . '</a>';
  		}
  
  		if ( current_user_can('edit_themes') )
! 			$actions['edit'] = '<a href="' . esc_url('theme-editor.php?theme=' . urlencode( $theme_key ) ) . '" title="' . esc_attr__('Open this theme in the Theme Editor') . '" class="edit">' . __('Edit') . '</a>';
  
! 		if ( ! $allowed && current_user_can( 'delete_themes' ) && ! $this->is_site_themes && $theme_key != get_option( 'stylesheet' ) && $theme_key != get_option( 'template' ) )
  			$actions['delete'] = '<a href="' . esc_url( wp_nonce_url( 'themes.php?action=delete-selected&amp;checked[]=' . $theme_key . '&amp;theme_status=' . $context . '&amp;paged=' . $page . '&amp;s=' . $s, 'bulk-themes' ) ) . '" title="' . esc_attr__( 'Delete this theme' ) . '" class="delete">' . __( 'Delete' ) . '</a>';
  
! 		$actions = apply_filters( 'theme_action_links', array_filter( $actions ), $theme_key, $theme, $context );
! 		$actions = apply_filters( "theme_action_links_$theme_key", $actions, $theme_key, $theme, $context );
  
  		$class = ! $allowed ? 'inactive' : 'active';
  		$checkbox_id = "checkbox_" . md5( $theme->get('Name') );
! 		$checkbox = "<input type='checkbox' name='checked[]' value='" . esc_attr( $theme_key ) . "' id='" . $checkbox_id . "' /><label class='screen-reader-text' for='" . $checkbox_id . "' >" . __('Select') . " " . $theme->display('Name') . "</label>";
  
  		$id = sanitize_html_class( $theme->get_stylesheet() );
  
--- 268,295 ----
  			'delete' => ''
  		);
  
! 		$stylesheet = $theme->get_stylesheet();
! 		$theme_key = urlencode( $stylesheet );
  
  		if ( ! $allowed ) {
  			if ( ! $theme->errors() )
! 				$actions['enable'] = '<a href="' . esc_url( wp_nonce_url($url . 'action=enable&amp;theme=' . $theme_key . '&amp;paged=' . $page . '&amp;s=' . $s, 'enable-theme_' . $stylesheet ) ) . '" title="' . esc_attr__('Enable this theme') . '" class="edit">' . ( $this->is_site_themes ? __( 'Enable' ) : __( 'Network Enable' ) ) . '</a>';
  		} else {
! 			$actions['disable'] = '<a href="' . esc_url( wp_nonce_url($url . 'action=disable&amp;theme=' . $theme_key . '&amp;paged=' . $page . '&amp;s=' . $s, 'disable-theme_' . $stylesheet ) ) . '" title="' . esc_attr__('Disable this theme') . '">' . ( $this->is_site_themes ? __( 'Disable' ) : __( 'Network Disable' ) ) . '</a>';
  		}
  
  		if ( current_user_can('edit_themes') )
! 			$actions['edit'] = '<a href="' . esc_url('theme-editor.php?theme=' . $theme_key ) . '" title="' . esc_attr__('Open this theme in the Theme Editor') . '" class="edit">' . __('Edit') . '</a>';
  
! 		if ( ! $allowed && current_user_can( 'delete_themes' ) && ! $this->is_site_themes && $stylesheet != get_option( 'stylesheet' ) && $stylesheet != get_option( 'template' ) )
  			$actions['delete'] = '<a href="' . esc_url( wp_nonce_url( 'themes.php?action=delete-selected&amp;checked[]=' . $theme_key . '&amp;theme_status=' . $context . '&amp;paged=' . $page . '&amp;s=' . $s, 'bulk-themes' ) ) . '" title="' . esc_attr__( 'Delete this theme' ) . '" class="delete">' . __( 'Delete' ) . '</a>';
  
! 		$actions = apply_filters( 'theme_action_links', array_filter( $actions ), $stylesheet, $theme, $context );
! 		$actions = apply_filters( "theme_action_links_$stylesheet", $actions, $stylesheet, $theme, $context );
  
  		$class = ! $allowed ? 'inactive' : 'active';
  		$checkbox_id = "checkbox_" . md5( $theme->get('Name') );
! 		$checkbox = "<input type='checkbox' name='checked[]' value='" . esc_attr( $stylesheet ) . "' id='" . $checkbox_id . "' /><label class='screen-reader-text' for='" . $checkbox_id . "' >" . __('Select') . " " . $theme->display('Name') . "</label>";
  
  		$id = sanitize_html_class( $theme->get_stylesheet() );
  
***************
*** 347,353 ****
  					if ( $theme->get('ThemeURI') )
  						$theme_meta[] = '<a href="' . $theme->display('ThemeURI') . '" title="' . esc_attr__( 'Visit theme homepage' ) . '">' . __( 'Visit Theme Site' ) . '</a>';
  
! 					$theme_meta = apply_filters( 'theme_row_meta', $theme_meta, $theme_key, $theme, $status );
  					echo implode( ' | ', $theme_meta );
  
  					echo "</div></td>";
--- 333,339 ----
  					if ( $theme->get('ThemeURI') )
  						$theme_meta[] = '<a href="' . $theme->display('ThemeURI') . '" title="' . esc_attr__( 'Visit theme homepage' ) . '">' . __( 'Visit Theme Site' ) . '</a>';
  
! 					$theme_meta = apply_filters( 'theme_row_meta', $theme_meta, $stylesheet, $theme, $status );
  					echo implode( ' | ', $theme_meta );
  
  					echo "</div></td>";
***************
*** 355,361 ****
  
  				default:
  					echo "<td class='$column_name column-$column_name'$style>";
! 					do_action( 'manage_themes_custom_column', $column_name, $theme_key, $theme );
  					echo "</td>";
  			}
  		}
--- 341,347 ----
  
  				default:
  					echo "<td class='$column_name column-$column_name'$style>";
! 					do_action( 'manage_themes_custom_column', $column_name, $stylesheet, $theme );
  					echo "</td>";
  			}
  		}
***************
*** 363,370 ****
  		echo "</tr>";
  
  		if ( $this->is_site_themes )
! 			remove_action( "after_theme_row_$theme_key", 'wp_theme_update_row' );
! 		do_action( 'after_theme_row', $theme_key, $theme, $status );
! 		do_action( "after_theme_row_$theme_key", $theme_key, $theme, $status );
  	}
  }
--- 349,356 ----
  		echo "</tr>";
  
  		if ( $this->is_site_themes )
! 			remove_action( "after_theme_row_$stylesheet", 'wp_theme_update_row' );
! 		do_action( 'after_theme_row', $stylesheet, $theme, $status );
! 		do_action( "after_theme_row_$stylesheet", $stylesheet, $theme, $status );
  	}
  }
diff -crBPN --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=advanced-cache.php --exclude=wp-cache-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.5.pl /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-admin/includes/class-wp-ms-users-list-table.php /home/packages/code/qi/SOURCES/wordpress-3.5/wp-admin/includes/class-wp-ms-users-list-table.php
*** /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-admin/includes/class-wp-ms-users-list-table.php	2012-10-29 12:35:30.000000000 -0500
--- /home/packages/code/qi/SOURCES/wordpress-3.5/wp-admin/includes/class-wp-ms-users-list-table.php	2012-12-17 16:18:41.000000000 -0600
***************
*** 165,170 ****
--- 165,171 ----
  				switch ( $column_name ) {
  					case 'cb': ?>
  						<th scope="row" class="check-column">
+ 							<label class="screen-reader-text" for="blog_<?php echo $user->ID; ?>"><?php echo sprintf( __( 'Select %s' ), $user->user_login ); ?></label>
  							<input type="checkbox" id="blog_<?php echo $user->ID ?>" name="allusers[]" value="<?php echo esc_attr( $user->ID ) ?>" />
  						</th>
  					<?php
***************
*** 172,182 ****
  
  					case 'username':
  						$avatar	= get_avatar( $user->user_email, 32 );
! 						if ( get_current_user_id() == $user->ID ) {
! 							$edit_link = esc_url( network_admin_url( 'profile.php' ) );
! 						} else {
! 							$edit_link = esc_url( network_admin_url( add_query_arg( 'wp_http_referer', urlencode( stripslashes( $_SERVER['REQUEST_URI'] ) ), 'user-edit.php?user_id=' . $user->ID ) ) );
! 						}
  
  						echo "<td $attributes>"; ?>
  							<?php echo $avatar; ?><strong><a href="<?php echo $edit_link; ?>" class="edit"><?php echo stripslashes( $user->user_login ); ?></a><?php
--- 173,179 ----
  
  					case 'username':
  						$avatar	= get_avatar( $user->user_email, 32 );
! 						$edit_link = esc_url( add_query_arg( 'wp_http_referer', urlencode( stripslashes( $_SERVER['REQUEST_URI'] ) ), get_edit_user_link( $user->ID ) ) );
  
  						echo "<td $attributes>"; ?>
  							<?php echo $avatar; ?><strong><a href="<?php echo $edit_link; ?>" class="edit"><?php echo stripslashes( $user->user_login ); ?></a><?php
